var fs = require('fs');

var comment = /\/\*\*[\s\S]*?\*\//gm,
	keyword = /@(\w+) (.+)$/,
	line = /\s*\*\s+(.*)$/,
	jstype = /\{(.+)\}/,
	param = /\}?\s*(\w+) (.+)/;

var primary = {
	module: true,
	method: true,
	'class': true,
	property: true
}

var templ = {

	param: function (str) {
		var t = (str.match(jstype)||['',''])[1],
			n = str.match(param);
		if (t) t = '*' + t + '*';
		return '* **Parameter** ' + t + ' **' + (n[1]||'') + '** ' + (n[2]||'');
	},
	return: function (str) {
		var t = (str.match(jstype)||['',''])[1],
			i = str.indexOf('}') + 1,
			s = str.substr(i);
		if (t) t = '*' + t + '*';
 		return '* **Return** ' + t  + s;
	},
	method: function (str) {
		return '## Method ' + str.trim() + '\n';;
	},
	property: function (str) {
		return '* **Property** ' +str;
	},
	module: function (str) {
		return '# Module ' + str.trim() + '\n';
	}
}

var fil = fs.readFileSync('kvp.js', 'utf8');

var m = fil.match(comment);

m.forEach(function (c) {
	var i,
		s,
		prim,
		heading,
		rows = [],
		r = c.split('\n');
	console.log('\n');
	for (i=1; i<r.length - 1; i++) {
		var k = r[i].match(keyword);
		if (k) {
			if (primary[k[1]]) {
				prim = k[1];
				heading = templ[k[1]](k[2]);
			} else if (templ[k[1]]) {
				rows.push(templ[k[1]](k[2]));
			}
		} else {
			s = r[i].match(line);
			if (s) {
				rows.push(s[1]);
			}
		}
	}
	//console.log('....', prim);
	if (heading) {
		console.log(heading);
		heading = null;
	}
	rows.forEach(function (r) {
		console.log(r);
	});
	console.log();
});

